Index: /trunk/src/sys/arch/mips/mips/cache_mipsNN.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/cache_mipsNN.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/cache_mipsNN.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cache_mipsNN.c,v 1.11.78.4 2010/05/11 20:55:22 matt Exp $	*/
+/*	$NetBSD: cache_mipsNN.c,v 1.11.78.5 2011/04/29 08:26:23 matt Exp $	*/
 
 /*
@@ -37,5 +37,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cache_mipsNN.c,v 1.11.78.4 2010/05/11 20:55:22 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cache_mipsNN.c,v 1.11.78.5 2011/04/29 08:26:23 matt Exp $");
 
 #include <sys/param.h>
@@ -61,5 +61,5 @@
 #endif
 
-#if defined(__mips_o32)
+#ifdef __mips_o32
 __asm(".set mips32");
 #else
@@ -69,6 +69,4 @@
 static int picache_stride;
 static int picache_loopcount;
-static int pdcache_stride;
-static int pdcache_loopcount;
 
 void
@@ -76,5 +74,5 @@
 {
 	struct mips_cache_info * const mci = &mips_cache_info;
-	int flush_multiple_lines_per_way;
+	bool flush_multiple_lines_per_way;
 
 	flush_multiple_lines_per_way = mci->mci_picache_way_size > PAGE_SIZE;
@@ -85,5 +83,5 @@
 		 * need to flush one pages' worth.
 		 */
-		flush_multiple_lines_per_way = 0;
+		flush_multiple_lines_per_way = false;
 	}
 
@@ -97,12 +95,4 @@
 	}
 
-	if (mci->mci_pdcache_way_size < PAGE_SIZE) {
-		pdcache_stride = mci->mci_pdcache_way_size;
-		pdcache_loopcount = mci->mci_pdcache_ways;
-	} else {
-		pdcache_stride = PAGE_SIZE;
-		pdcache_loopcount = (mci->mci_pdcache_way_size / PAGE_SIZE) *
-		    mci->mci_pdcache_ways;
-	}
 #define CACHE_DEBUG
 #ifdef CACHE_DEBUG
@@ -111,6 +101,4 @@
 	printf("  picache_stride    = %d\n", picache_stride);
 	printf("  picache_loopcount = %d\n", picache_loopcount);
-	printf("  pdcache_stride    = %d\n", pdcache_stride);
-	printf("  pdcache_loopcount = %d\n", pdcache_loopcount);
 #endif
 }
@@ -229,4 +217,13 @@
 
 	/*
+	 * If we are going to flush more than is in a way, we are flushing
+	 * everything.
+	 */
+	if (eva - va >= mci->mci_picache_way_size) {
+		mipsNN_icache_sync_all_16();
+		return;
+	}
+
+	/*
 	 * GCC generates better code in the loops if we reference local
 	 * copies of these global variables.
@@ -239,7 +236,8 @@
 	while ((eva - va) >= (8 * 16)) {
 		tmpva = va;
-		for (i = 0; i < loopcount; i++, tmpva += stride)
+		for (i = 0; i < loopcount; i++, tmpva += stride) {
 			cache_r4k_op_8lines_16(tmpva,
 			    CACHE_R4K_I|CACHEOP_R4K_INDEX_INV);
+		}
 		va += 8 * 16;
 	}
@@ -247,7 +245,8 @@
 	while (va < eva) {
 		tmpva = va;
-		for (i = 0; i < loopcount; i++, tmpva += stride)
+		for (i = 0; i < loopcount; i++, tmpva += stride) {
 			cache_op_r4k_line(tmpva,
 			    CACHE_R4K_I|CACHEOP_R4K_INDEX_INV);
+		}
 		va += 16;
 	}
@@ -267,12 +266,16 @@
 	 * address out of them.
 	 */
-	if (size >= mci->mci_picache_way_size) {
-		va = MIPS_KSEG0_START;
-		eva = va + mci->mci_picache_way_size;
-	} else {
-		va = MIPS_PHYS_TO_KSEG0(va & mci->mci_picache_way_mask);
-
-		eva = round_line32(va + size);
-		va = trunc_line32(va);
+	va = MIPS_PHYS_TO_KSEG0(va & mci->mci_picache_way_mask);
+
+	eva = round_line32(va + size);
+	va = trunc_line32(va);
+
+	/*
+	 * If we are going to flush more than is in a way, we are flushing
+	 * everything.
+	 */
+	if (eva - va >= mci->mci_picache_way_size) {
+		mipsNN_icache_sync_all_32();
+		return;
 	}
 
@@ -288,7 +291,8 @@
 	while ((eva - va) >= (8 * 32)) {
 		tmpva = va;
-		for (i = 0; i < loopcount; i++, tmpva += stride)
+		for (i = 0; i < loopcount; i++, tmpva += stride) {
 			cache_r4k_op_8lines_32(tmpva,
 			    CACHE_R4K_I|CACHEOP_R4K_INDEX_INV);
+		}
 		va += 8 * 32;
 	}
@@ -296,7 +300,8 @@
 	while (va < eva) {
 		tmpva = va;
-		for (i = 0; i < loopcount; i++, tmpva += stride)
+		for (i = 0; i < loopcount; i++, tmpva += stride) {
 			cache_op_r4k_line(tmpva,
 			    CACHE_R4K_I|CACHEOP_R4K_INDEX_INV);
+		}
 		va += 32;
 	}
@@ -393,11 +398,7 @@
 }
 
-void
-mipsNN_pdcache_wbinv_range_index_16(vaddr_t va, vsize_t size)
-{
-	struct mips_cache_info * const mci = &mips_cache_info;
-	vaddr_t eva, tmpva;
-	int i, stride, loopcount;
-
+static void
+mipsNN_pdcache_wbinv_range_index_16_intern(vaddr_t va, vaddr_t eva)
+{
 	/*
 	 * Since we're doing Index ops, we expect to not be able
@@ -406,40 +407,20 @@
 	 * address out of them.
 	 */
-	va = MIPS_PHYS_TO_KSEG0(va & mci->mci_pdcache_way_mask);
-
-	eva = round_line16(va + size);
-	va = trunc_line16(va);
-
-	/*
-	 * GCC generates better code in the loops if we reference local
-	 * copies of these global variables.
-	 */
-	stride = pdcache_stride;
-	loopcount = pdcache_loopcount;
-
-	while ((eva - va) >= (8 * 16)) {
-		tmpva = va;
-		for (i = 0; i < loopcount; i++, tmpva += stride)
-			cache_r4k_op_8lines_16(tmpva,
-			    CACHE_R4K_D|CACHEOP_R4K_INDEX_WB_INV);
-		va += 8 * 16;
-	}
-
-	while (va < eva) {
-		tmpva = va;
-		for (i = 0; i < loopcount; i++, tmpva += stride)
-			cache_op_r4k_line(tmpva,
-			    CACHE_R4K_D|CACHEOP_R4K_INDEX_WB_INV);
-		va += 16;
-	}
-}
-
-void
-mipsNN_pdcache_wbinv_range_index_32(vaddr_t va, vsize_t size)
-{
-	struct mips_cache_info * const mci = &mips_cache_info;
-	vaddr_t eva, tmpva;
-	int i, stride, loopcount;
-
+	va = MIPS_PHYS_TO_KSEG0(va);
+	eva = MIPS_PHYS_TO_KSEG0(eva);
+
+	for (; (eva - va) >= (8 * 16); va += 8 * 16) {
+		cache_r4k_op_8lines_16(va,
+		    CACHE_R4K_D|CACHEOP_R4K_INDEX_WB_INV);
+	}
+
+	for (; va < eva; va += 16) {
+		cache_op_r4k_line(va, CACHE_R4K_D|CACHEOP_R4K_INDEX_WB_INV);
+	}
+}
+
+static void
+mipsNN_pdcache_wbinv_range_index_32_intern(vaddr_t va, vaddr_t eva)
+{
 	/*
 	 * Since we're doing Index ops, we expect to not be able
@@ -448,30 +429,82 @@
 	 * address out of them.
 	 */
-	va = MIPS_PHYS_TO_KSEG0(va & mci->mci_pdcache_way_mask);
-
+	va = MIPS_PHYS_TO_KSEG0(va);
+	eva = MIPS_PHYS_TO_KSEG0(eva);
+
+	for (; (eva - va) >= (8 * 32); va += 8 * 32) {
+		cache_r4k_op_8lines_32(va,
+		    CACHE_R4K_D|CACHEOP_R4K_INDEX_WB_INV);
+	}
+
+	for (; va < eva; va += 32) {
+		cache_op_r4k_line(va, CACHE_R4K_D|CACHEOP_R4K_INDEX_WB_INV);
+	}
+}
+
+void
+mipsNN_pdcache_wbinv_range_index_16(vaddr_t va, vsize_t size)
+{
+	struct mips_cache_info * const mci = &mips_cache_info;
+	const vaddr_t way_size = mci->mci_pdcache_way_size;
+	const vaddr_t way_mask = way_size - 1;
+	const u_int ways = mci->mci_pdcache_ways;
+	vaddr_t eva;
+
+	va &= way_mask;
+	eva = round_line16(va + size);
+	va = trunc_line16(va);
+
+	/*
+	 * If we are going to flush more than is in a way, we are flushing
+	 * everything.
+	 */
+	if (eva - va >= way_size) {
+		mipsNN_pdcache_wbinv_all_16();
+		return;
+	}
+
+	/*
+	 * Invalidate each way.  If the address range wraps past the end of
+	 * the way, we will be invalidating in two ways but eventually things
+	 * work out since the last way will wrap into the first way.
+	 */
+	for (u_int way = 0; way < ways; way++) {
+		mipsNN_pdcache_wbinv_range_index_16_intern(va, eva);
+		va += way_size;
+		eva += way_size;
+	}
+}
+ 
+void
+mipsNN_pdcache_wbinv_range_index_32(vaddr_t va, vsize_t size)
+{
+	struct mips_cache_info * const mci = &mips_cache_info;
+	const vaddr_t way_size = mci->mci_pdcache_way_size;
+	const vaddr_t way_mask = way_size - 1;
+	const u_int ways = mci->mci_pdcache_ways;
+	vaddr_t eva;
+
+	va &= way_mask;
 	eva = round_line32(va + size);
 	va = trunc_line32(va);
 
 	/*
-	 * GCC generates better code in the loops if we reference local
-	 * copies of these global variables.
-	 */
-	stride = pdcache_stride;
-	loopcount = pdcache_loopcount;
-
-	while ((eva - va) >= (8 * 32)) {
-		tmpva = va;
-		for (i = 0; i < loopcount; i++, tmpva += stride)
-			cache_r4k_op_8lines_32(tmpva,
-			    CACHE_R4K_D|CACHEOP_R4K_INDEX_WB_INV);
-		va += 8 * 32;
-	}
-
-	while (va < eva) {
-		tmpva = va;
-		for (i = 0; i < loopcount; i++, tmpva += stride)
-			cache_op_r4k_line(tmpva,
-			    CACHE_R4K_D|CACHEOP_R4K_INDEX_WB_INV);
-		va += 32;
+	 * If we are going to flush more than is in a way, we are flushing
+	 * everything.
+	 */
+	if (eva - va >= way_size) {
+		mipsNN_pdcache_wbinv_all_32();
+		return;
+	}
+
+	/*
+	 * Invalidate each way.  If the address range wraps past the end of
+	 * the way, we will be invalidating in two ways but eventually things
+	 * work out since the last way will wrap into the first way.
+	 */
+	for (u_int way = 0; way < ways; way++) {
+		mipsNN_pdcache_wbinv_range_index_32_intern(va, eva);
+		va += way_size;
+		eva += way_size;
 	}
 }
Index: /trunk/src/sys/arch/mips/mips/cache_r5k.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/cache_r5k.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/cache_r5k.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cache_r5k.c,v 1.12.96.1 2010/01/20 09:04:35 matt Exp $	*/
+/*	$NetBSD: cache_r5k.c,v 1.12.96.2 2011/04/29 08:26:23 matt Exp $	*/
 
 /*
@@ -37,5 +37,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cache_r5k.c,v 1.12.96.1 2010/01/20 09:04:35 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cache_r5k.c,v 1.12.96.2 2011/04/29 08:26:23 matt Exp $");
 
 #include <sys/param.h>
@@ -622,6 +622,6 @@
 }
 
-#define	round_page(x)		(((x) + (128 * 32 - 1)) & ~(128 * 32 - 1))
-#define	trunc_page(x)		((x) & ~(128 * 32 - 1))
+#define	mips_r5k_round_page(x)	(((x) + (128 * 32 - 1)) & ~(128 * 32 - 1))
+#define	mips_r5k_trunc_page(x)	((x) & ~(128 * 32 - 1))
 
 void
@@ -629,7 +629,7 @@
 {
 	uint32_t ostatus, taglo;
-	vaddr_t eva = round_page(va + size);
-
-	va = trunc_page(va);
+	vaddr_t eva = mips_r5k_round_page(va + size);
+
+	va = mips_r5k_trunc_page(va);
 
 	__asm volatile(
Index: /trunk/src/sys/arch/mips/mips/compat_13_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/compat_13_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/compat_13_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: compat_13_machdep.c,v 1.16.20.4 2010/02/01 04:16:19 matt Exp $	*/
+/*	$NetBSD: compat_13_machdep.c,v 1.16.20.6 2011/04/29 08:26:23 matt Exp $	*/
 
 /*
@@ -16,5 +16,5 @@
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: compat_13_machdep.c,v 1.16.20.4 2010/02/01 04:16:19 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: compat_13_machdep.c,v 1.16.20.6 2011/04/29 08:26:23 matt Exp $");
 
 #include <sys/param.h>
@@ -23,5 +23,4 @@
 #include <sys/kernel.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/mount.h>
 #include <sys/syscallargs.h>
@@ -31,4 +30,6 @@
 
 #include <mips/regnum.h>
+#include <mips/locore.h>
+#include <mips/pcb.h>
 
 #ifdef DEBUG
@@ -88,7 +89,8 @@
 		tf->tf_regs[i] = scp->sc_regs[i];
 #endif
-	if (scp->sc_fpused)
-		*(struct fpreg *)&l->l_addr->u_pcb.pcb_fpregs =
-		    *(struct fpreg *)scp->sc_fpregs;
+	if (scp->sc_fpused) {
+		struct pcb * const pcb = lwp_getpcb(l);
+		*(struct fpreg *)&pcb->pcb_fpregs = *(struct fpreg *)scp->sc_fpregs;
+	}
 
 	mutex_enter(p->p_lock);
Index: /trunk/src/sys/arch/mips/mips/compat_16_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/compat_16_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/compat_16_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: compat_16_machdep.c,v 1.12.14.6 2010/02/28 23:45:06 matt Exp $	*/
+/*	$NetBSD: compat_16_machdep.c,v 1.12.14.7 2011/04/29 08:26:23 matt Exp $	*/
 
 /*-
@@ -46,9 +46,11 @@
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 	
-__KERNEL_RCSID(0, "$NetBSD: compat_16_machdep.c,v 1.12.14.6 2010/02/28 23:45:06 matt Exp $"); 
-
+__KERNEL_RCSID(0, "$NetBSD: compat_16_machdep.c,v 1.12.14.7 2011/04/29 08:26:23 matt Exp $"); 
+
+#ifdef _KERNEL_OPT
 #include "opt_cputype.h"
 #include "opt_compat_netbsd.h"
 #include "opt_compat_ultrix.h"
+#endif
 
 #include <sys/param.h>
@@ -56,5 +58,5 @@
 #include <sys/kernel.h>
 #include <sys/proc.h>
-#include <sys/user.h>
+#include <sys/cpu.h>
 #include <sys/signal.h>
 #include <sys/signalvar.h>
@@ -65,9 +67,9 @@
 #include <compat/sys/signalvar.h>
 
-#include <machine/cpu.h>
-
 #include <mips/regnum.h>
 #include <mips/frame.h>
 #include <mips/locore.h>
+#include <mips/pcb.h>
+#include <mips/reg.h>
 
 #if !defined(__mips_o32)
@@ -90,11 +92,12 @@
 {
 	int sig = ksi->ksi_signo;
-	struct lwp *l = curlwp;
-	struct proc *p = l->l_proc;
-	struct sigacts *ps = p->p_sigacts;
+	struct lwp * const l = curlwp;
+	struct proc * const p = l->l_proc;
+	struct sigacts * const ps = p->p_sigacts;
+	struct pcb * const pcb = lwp_getpcb(l);
 	int onstack, error;
 	struct sigcontext *scp = getframe(l, sig, &onstack);
 	struct sigcontext ksc;
-	struct trapframe *tf = l->l_md.md_utf;
+	struct trapframe * const tf = l->l_md.md_utf;
 	sig_t catcher = SIGACTION(p, sig).sa_handler;
 
@@ -129,12 +132,12 @@
 
 	/* Save the FP state, if necessary, then copy it. */
-#if defined(FPEMUL) || !defined(NOFPU)
-	ksc.sc_fpused = l->l_md.md_flags & MDP_FPUSED;
+	ksc.sc_fpused = fpu_used_p(l);
+#if !defined(NOFPU)
 	if (ksc.sc_fpused) {
 		/* if FPU has current state, save it first */
-		fpusave_lwp(l);
-	}
-#endif
-	*(struct fpreg *)ksc.sc_fpregs = *(struct fpreg *)&l->l_addr->u_pcb.pcb_fpregs;
+		fpu_save();
+	}
+#endif
+	*(struct fpreg *)ksc.sc_fpregs = *(struct fpreg *)&pcb->pcb_fpregs;
 
 	/* Save signal stack. */
@@ -234,6 +237,7 @@
 	} */
 	struct sigcontext *scp, ksc;
-	struct trapframe *tf = l->l_md.md_utf;
-	struct proc *p = l->l_proc;
+	struct trapframe * const tf = l->l_md.md_utf;
+	struct proc * const p = l->l_proc;
+	struct pcb * const pcb = lwp_getpcb(l);
 	int error;
 
@@ -270,9 +274,10 @@
 		tf->tf_regs[i] = ksc.sc_regs[i];
 #endif
-#if defined(FPEMUL) || !defined(NOFPU)
-	if (scp->sc_fpused)
-		fpudiscard_lwp(l);
-#endif
-	*(struct fpreg *)&l->l_addr->u_pcb.pcb_fpregs = *(struct fpreg *)scp->sc_fpregs;
+#if !defined(NOFPU)
+	if (scp->sc_fpused) {
+		fpu_discard();
+	}
+#endif
+	*(struct fpreg *)&pcb->pcb_fpregs = *(struct fpreg *)scp->sc_fpregs;
 
 	mutex_enter(p->p_lock);
Index: /trunk/src/sys/arch/mips/mips/copy.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/copy.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/copy.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: copy.S,v 1.5.38.6 2009/12/11 17:17:51 matt Exp $	*/
+/*	$NetBSD: copy.S,v 1.5.38.7 2011/04/29 08:26:24 matt Exp $	*/
 
 /*
@@ -71,21 +71,22 @@
 	move	t0, a2
 	beq	a2, zero, 4f
+	 nop
 1:
 	lbu	v0, 0(a0)
 	PTR_SUBU a2, a2, 1
 	beq	v0, zero, 2f
-	sb	v0, 0(a1)			# each byte until NIL
+	 sb	v0, 0(a1)			# each byte until NIL
 	PTR_ADDU a0, a0, 1
 	bne	a2, zero, 1b			# less than maxlen
-	PTR_ADDU a1, a1, 1
+	 PTR_ADDU a1, a1, 1
 4:
 	li	v0, ENAMETOOLONG		# run out of space
 2:
 	beq	a3, zero, 3f			# return num. of copied bytes
-	PTR_SUBU a2, t0, a2			# if the 4th arg was non-NULL
+	 PTR_SUBU a2, t0, a2			# if the 4th arg was non-NULL
 	PTR_S	a2, 0(a3)
 3:
 	j	ra				# v0 is 0 or ENAMETOOLONG
-	nop
+	 nop
 END(copystr)
 
@@ -98,10 +99,10 @@
  */
 LEAF(copyinstr)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	PTR_LA	v0, _C_LABEL(copystrerr)
 	la	t0, VM_MAXUSER_ADDRESS
 	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(copystrerr)
-	 PTR_S	v0, U_PCB_ONFAULT(v1)
+	beqz	t0, _C_LABEL(copystrefault)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	move	t0, a2
 	beq	a2, zero, 4f
@@ -123,5 +124,5 @@
 3:
 	j	ra				# v0 is 0 or ENAMETOOLONG
-	 PTR_S	zero, U_PCB_ONFAULT(v1)
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(copyinstr)
 
@@ -134,36 +135,41 @@
  */
 LEAF(copyoutstr)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	PTR_LA	v0, _C_LABEL(copystrerr)
 	la	t0, VM_MAXUSER_ADDRESS
 	sltu	t0, a1, t0
-	beqz	t0, _C_LABEL(copystrerr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	beqz	t0, _C_LABEL(copystrefault)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	move	t0, a2
 	beq	a2, zero, 4f
+	 nop
 1:
 	lbu	v0, 0(a0)
 	PTR_SUBU a2, a2, 1
 	beq	v0, zero, 2f
-	sb	v0, 0(a1)
+	 sb	v0, 0(a1)
 	PTR_ADDU a0, a0, 1
 	bne	a2, zero, 1b
-	PTR_ADDU a1, a1, 1
+	 PTR_ADDU a1, a1, 1
 4:
 	li	v0, ENAMETOOLONG
 2:
 	beq	a3, zero, 3f
-	PTR_SUBU a2, t0, a2
+	 PTR_SUBU a2, t0, a2
 	PTR_S	a2, 0(a3)
 3:
 	j	ra				# v0 is 0 or ENAMETOOLONG
-	PTR_S	zero, U_PCB_ONFAULT(v1)
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(copyoutstr)
 
 LEAF(copystrerr)
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	li	v0, EFAULT			# return EFAULT
+	j	ra
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(copystrerr)
+
+LEAF(copystrefault)
+	b	copystrerr
+	 li	v0, EFAULT
+END(copystrefault)
 
 /*
@@ -186,27 +192,26 @@
 	move	a0, a1
 	move	a1, v0
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)		# set up fault handler
+	PTR_L	v1, L_PCB(MIPS_CURLWP)		# set up fault handler
 	PTR_LA	v0, _C_LABEL(kcopyerr)
-	PTR_L	s0, U_PCB_ONFAULT(v1)		# save old handler
+	PTR_L	s0, PCB_ONFAULT(v1)		# save old handler
 	jal	memcpy
-	PTR_S	v0, U_PCB_ONFAULT(v1)
-
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)		# restore the old handler
+	 PTR_S	v0, PCB_ONFAULT(v1)
+
+	PTR_L	v1, L_PCB(MIPS_CURLWP)		# restore the old handler
 	REG_L	ra, CALLFRAME_SIZ+CALLFRAME_RA(sp)	# restore ra
-	PTR_S	s0, U_PCB_ONFAULT(v1)
+	PTR_S	s0, PCB_ONFAULT(v1)
 	REG_L	s0, CALLFRAME_SIZ+CALLFRAME_S0(sp)	# restore s0
 	PTR_ADDU sp, sp, 2*CALLFRAME_SIZ	# kill stack frame
 	j	ra
-	move	v0, zero			# success!
+	 move	v0, zero			# success!
 END(kcopy)
 
 LEAF(kcopyerr)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)		# restore the old handler
+	PTR_L	v1, L_PCB(MIPS_CURLWP)		# restore the old handler
 	REG_L	ra, CALLFRAME_SIZ+CALLFRAME_RA(sp) 	# restore ra
-	PTR_S	s0, U_PCB_ONFAULT(v1)
+	PTR_S	s0, PCB_ONFAULT(v1)
 	REG_L	s0, CALLFRAME_SIZ+CALLFRAME_S0(sp) 	# restore s0
-	PTR_ADDU sp, sp, 2*CALLFRAME_SIZ	# kill stack frame
-	j	ra
-	li	v0, EFAULT			# return EFAULT
+	j	ra
+	 PTR_ADDU sp, sp, 2*CALLFRAME_SIZ	# kill stack frame
 END(kcopyerr)
 
@@ -223,19 +228,19 @@
 	la	t0, VM_MAXUSER_ADDRESS
 	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(copyerr)
-	move	v0, a0				# swap a0, a1 for call to memcpy
+	beqz	t0, _C_LABEL(copyefault)
+	 move	v0, a0				# swap a0, a1 for call to memcpy
 	move	a0, a1
 	move	a1, v0
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	PTR_LA	v0, _C_LABEL(copyerr)
 	jal	memcpy
-	PTR_S	v0, U_PCB_ONFAULT(v1)
-
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	 PTR_S	v0, PCB_ONFAULT(v1)
+
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	REG_L	ra, CALLFRAME_RA(sp)
 	PTR_ADDU sp, sp, CALLFRAME_SIZ
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero
 END(copyin)
 
@@ -252,29 +257,33 @@
 	la	t0, VM_MAXUSER_ADDRESS
 	sltu	t0, a1, t0
-	beqz	t0, _C_LABEL(copyerr)
-	move	v0, a0				# swap a0, a1 for call to memcpy
+	beqz	t0, _C_LABEL(copyefault)
+	 move	v0, a0				# swap a0, a1 for call to memcpy
 	move	a0, a1
 	move	a1, v0
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	PTR_LA	v0, _C_LABEL(copyerr)
 	jal	memcpy
-	PTR_S	v0, U_PCB_ONFAULT(v1)
-
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	 PTR_S	v0, PCB_ONFAULT(v1)
+
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	REG_L	ra, CALLFRAME_RA(sp)
 	PTR_ADDU sp, sp, CALLFRAME_SIZ
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero
 END(copyout)
 
 LEAF(copyerr)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	REG_L	ra, CALLFRAME_RA(sp)
 	PTR_ADDU sp, sp, CALLFRAME_SIZ
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	li	v0, EFAULT			# return EFAULT
+	j	ra
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(copyerr)
+
+LEAF(copyefault)
+	b	copyerr
+	 li	v0, EFAULT
+END(copyefault)
 
 /*
@@ -284,14 +293,14 @@
  */
 LEAF(fuswintr)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	PTR_LA	v0, _C_LABEL(fswintrberr)
-	PTR_L	a2, U_PCB_ONFAULT(v1)
+	PTR_L	a2, PCB_ONFAULT(v1)
 	la	t0, VM_MAXUSER_ADDRESS
 	sltu	t0, a0, t0
 	beqz	t0, _C_LABEL(fswintrberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	lhu	v0, 0(a0)			# fetch short
 	j	ra
-	PTR_S	a2, U_PCB_ONFAULT(v1)
+	 PTR_S	a2, PCB_ONFAULT(v1)
 END(fuswintr)
 
@@ -302,15 +311,15 @@
  */
 LEAF(suswintr)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	PTR_LA	v0, _C_LABEL(fswintrberr)
-	PTR_L	a2, U_PCB_ONFAULT(v1)
+	PTR_L	a2, PCB_ONFAULT(v1)
 	la	t0, VM_MAXUSER_ADDRESS
 	sltu	t0, a0, t0
 	beqz	t0, _C_LABEL(fswintrberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	sh	a1, 0(a0)			# store short
-	PTR_S	a2, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero
+	PTR_S	a2, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero
 END(suswintr)
 
@@ -320,13 +329,13 @@
  */
 LEAF(ufetch_uint32)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	INT_L	v0, 0(a0)			# fetch int
 	j	ra
-	PTR_S	zero, U_PCB_ONFAULT(v1)
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(ufetch_uint32)
 STRONG_ALIAS(ufetch_int32, ufetch_uint32)
@@ -354,13 +363,13 @@
  */
 LEAF(ufetch_uint64)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	LONG_L	v0, 0(a0)			# fetch 64-bit datum
 	j	ra
-	PTR_S	zero, U_PCB_ONFAULT(v1)
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(ufetch_uint64)
 STRONG_ALIAS(ufetch_int64, ufetch_uint64)
@@ -381,13 +390,13 @@
  */
 LEAF(ufetch_uint16)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	lhu	v0, 0(a0)			# fetch short
 	j	ra
-	PTR_S	zero, U_PCB_ONFAULT(v1)
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(ufetch_uint16)
 STRONG_ALIAS(ufetch_ushort, ufetch_uint16)
@@ -402,13 +411,13 @@
  */
 LEAF(ufetch_int16)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	lh	v0, 0(a0)			# fetch short
 	j	ra
-	PTR_S	zero, U_PCB_ONFAULT(v1)
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(ufetch_int16)
 STRONG_ALIAS(ufetch_short, ufetch_int16)
@@ -421,13 +430,13 @@
  */
 LEAF(ufetch_uint8)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	lbu	v0, 0(a0)			# fetch byte
 	j	ra
-	PTR_S	zero, U_PCB_ONFAULT(v1)
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(ufetch_uint8)
 STRONG_ALIAS(ufetch_uchar, ufetch_uint8)
@@ -442,13 +451,13 @@
  */
 LEAF(ufetch_int8)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	lb	v0, 0(a0)			# fetch byte
 	j	ra
-	PTR_S	zero, U_PCB_ONFAULT(v1)
+	 PTR_S	zero, PCB_ONFAULT(v1)
 END(ufetch_int8)
 STRONG_ALIAS(ufetch_char, ufetch_int8)
@@ -461,14 +470,14 @@
  */
 LEAF(ustore_uint32)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	INT_S	a1, 0(a0)			# store word
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero
 END(ustore_uint32)
 STRONG_ALIAS(ustore_int32, ustore_uint32)
@@ -494,16 +503,16 @@
  */
 LEAF(ustore_uint32_isync)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	INT_S	a1, 0(a0)			# store word
-	PTR_S	zero, U_PCB_ONFAULT(v1)
+	PTR_S	zero, PCB_ONFAULT(v1)
+	PTR_L	v1, _C_LABEL(mips_cache_ops) + MIPSX_FLUSHICACHE
 	move	v0, zero
-	PTR_L	v1, _C_LABEL(mips_cache_ops) + MIPSX_FLUSHICACHE
 	j	v1				# NOTE: must not clobber v0!
-	li	a1, 4				# size of word
+	 li	a1, 4				# size of word
 END(ustore_uint32_isync)
 
@@ -514,14 +523,14 @@
  */
 LEAF(ustore_uint64)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	LONG_S	a1, 0(a0)			# store word
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero
 END(ustore_uint64)
 STRONG_ALIAS(ustore_int64, ustore_uint64)
@@ -545,14 +554,14 @@
  */
 LEAF(ustore_uint16)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	sh	a1, 0(a0)			# store short
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero
 END(ustore_uint16)
 STRONG_ALIAS(ustore_int16, ustore_uint16)
@@ -567,14 +576,14 @@
  */
 LEAF(ustore_uint8)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
-	PTR_LA	v0, _C_LABEL(fswberr)
-	la	t0, VM_MAXUSER_ADDRESS
-	sltu	t0, a0, t0
-	beqz	t0, _C_LABEL(fswberr)
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
+	PTR_LA	v0, _C_LABEL(fswberr)
+	la	t0, VM_MAXUSER_ADDRESS
+	sltu	t0, a0, t0
+	beqz	t0, _C_LABEL(fswberr)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	sb	a1, 0(a0)			# store byte
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero
 END(ustore_uint8)
 STRONG_ALIAS(ustore_int8, ustore_uint8)
@@ -590,21 +599,21 @@
  */
 LEAF(badaddr)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	PTR_LA	v0, _C_LABEL(baderr)
 	bne	a1, 1, 2f
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	b	5f
-	lbu	v0, (a0)
+	 lbu	v0, (a0)
 2:
 	bne	a1, 2, 4f
-	nop
+	 nop
 	b	5f
-	lhu	v0, (a0)
+	 lhu	v0, (a0)
 4:
 	INT_L	v0, (a0)
 5:
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero		# made it w/o errors
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero		# made it w/o errors
 END(badaddr)
 
@@ -617,13 +626,13 @@
 LEAF(fswintrberr)
 	nop
-	PTR_S	a2, U_PCB_ONFAULT(v1)
-	j	ra
-	li	v0, -1
+	PTR_S	a2, PCB_ONFAULT(v1)
+	j	ra
+	 li	v0, -1
 END(fswintrberr)
 
 LEAF(fswberr)
 XLEAF(baderr)
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	li	v0, -1
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 li	v0, -1
 END(fswberr)
